var static = require('node-static');
var http = require('http');
var file = new(static.Server)();
var server = http.createServer(function (req, res) {
  file.serve(req, res);
});

// Chargement de socket.io
var io = require('socket.io').listen(server);

var speaker = {};  
var listenner = {};

function traceObj(o) {
	var s = "";
	for (var i in o) { 
		try {
			//print out in form "propertyname:::value"
			s += i + ":::" + o[i] + "\n";
		} catch (ex) {
			//just ignore error and continue with next iteration(=property)
			continue;
		}
	}
	return s;
}

io.sockets.on('connection', function (socket) {

    socket.on('helloMessage', function (helloMsg) {
		if (helloMsg.isListenner) {
			console.log('Listenner connecté');
			listenner.socket = socket;
			socket.isListenner = true;
			listenner.socket.emit('speakersNumbUpdate', speaker.hasOwnProperty("socket")?1:0);
			if (speaker.hasOwnProperty("socket")) speaker.socket.emit('helloMessage', helloMsg);
			console.log('Broadcasting hello Msg du listenner');
		} else {
			console.log('speaker connecté');
			speaker.socket = socket;
			socket.isListenner = false;
			if (listenner.hasOwnProperty("socket")) {
				listenner.socket.emit('speakersNumbUpdate', 1);
				listenner.socket.emit('helloMessage', helloMsg);
			}
		}
    });

	socket.on('rtcSignal', function (signal) {
		if (socket.isListenner && speaker.hasOwnProperty("socket")) {
			speaker.socket.emit('rtcSignal', signal);
			console.log('Relaying rtc signalling msg to speaker');
		} else if (!socket.isListenner && listenner.hasOwnProperty("socket")) {
			listenner.socket.emit('rtcSignal', signal);
			console.log('Relaying rtc signalling msg to listenner');
		} else {
			console.log("Protocol ERREUR: \nSignal: " + traceObj(signal));
		}
	});

	socket.on('disconnect', function (reason) {
		if (!socket.isListenner) {
			console.log('Speaker deconnecté');
			speaker = {};
			if (listenner.socket) {
				listenner.socket.emit('speakersNumbUpdate', 0);
			}
		} else {
			console.log('le listenner est deconnecté');
			listenner = {};
			if (speaker.hasOwnProperty("socket")) speaker.socket.emit('listennerOff');
		}
    });
});

console.log("Server Start");

server.listen(2014);
